require "planet"
require "planetling"

-- Run once on load
function love.load()
  planets = {};
  
  gravity = 80000;
  
  pause = false;

  planets[1] = planet:new(70, 70, (SCREEN_WIDTH/2) + 100, (SCREEN_HEIGHT/2) - 100, 2, 100, 200)
  planets[2] = planet:new(70, 70, (SCREEN_WIDTH/2) - 100, (SCREEN_HEIGHT/2) + 100, 1, -100, -200)
  -- Each planet has a vaguely random mass and position. They will move away from each other naturally. 
  for i = 3, 9 do
    planets[i] = planetling:new(math.random(10)*20, 2+math.random(4), 900+math.random(50), 300+math.random(100), 100, 200)
	end
end

-- dist between in 2d land
function math.dist(ax, az, bx, bz) 
    return math.sqrt((bx - ax)*(bx - ax) + (bz - az)*(bz - az));
end

function love.draw()
  -- Draw BG
  love.graphics.setColor(100,149,237) -- Cornflower Blue
  love.graphics.rectangle("fill", 0, 0, love.graphics.getWidth(), love.graphics.getHeight())
  
  -- Draw planets and blobs
  love.graphics.setColor(0, 0, 0)
  for i = 1, #planets do
		planets[i]:draw()
	end
  
  -- Return the colour back to normal
  love.graphics.setColor(255, 255, 255)
end

function love.update(dt)
  if not pause then    
    for i = 1, #planets do
      planets[i]:update(dt)
    end
  end
end

function love.keypressed(key)
  if key == 'p' then
    pause = not pause;
  end
end

function love.HSL(h, s, l, a)
    if s<=0 then return l,l,l,a end
    h, s, l = h/256*6, s/255, l/255
    local c = (1-math.abs(2*l-1))*s
    local x = (1-math.abs(h%2-1))*c
    local m,r,g,b = (l-.5*c), 0,0,0
    if h < 1     then r,g,b = c,x,0
    elseif h < 2 then r,g,b = x,c,0
    elseif h < 3 then r,g,b = 0,c,x
    elseif h < 4 then r,g,b = 0,x,c
    elseif h < 5 then r,g,b = x,0,c
    else              r,g,b = c,0,x
    end return (r+m)*255,(g+m)*255,(b+m)*255,a
end

